%test mex functions for W_2


%Input data
dx=2048;
x = (0: 1 / (dx - 1): 1).';
mu_x=exp(-(x - 0.5).^2 / 0.2^2);
mu_x=mu_x./sum(mu_x(:));

dy=1024;
y = (0: 1 / (dy - 1): 1).';
mu_y=exp(-(y - 0.25).^2 / 0.1^2) + exp(-(y - 0.75).^2 / 0.1^2);
mu_y=mu_y./sum(mu_y(:));

% Cost matrix between support of input densities mu_x ad mu_y
C = (abs(repmat(x,[1 dy])-repmat(y',[dx 1]))).^2;
display(['Optimal transport problem of size ' num2str(dx) ' x ' num2str(dy)]);
tic
[dist T]=mexEMD(mu_x,mu_y,C);
time_OT=toc;
cost_OT=sqrt(sum(T(:).*C(:)));
display(['Solution found in ' num2str(time_OT) ' s. Cost=' num2str(cost_OT)]);

d_z=128;
z = (0: 1 / (d_z - 1): 1)';
%cost matrices to the barycenter
Cx = (abs(repmat(x,[1 d_z])-repmat(z',[dx 1]))).^2;
Cy = (abs(repmat(z,[1 dy])-repmat(y',[d_z 1]))).^2;


tic
[dist_approx, Tx, Ty]=mexBAR(mu_x,mu_y,Cx,Cy);
time_app1=toc;
T_approx=Tx*Ty;

cost_OT_app1=sqrt(sum(Tx(:).*Cx(:)))+sqrt(sum(Ty(:).*Cy(:)));
display(['Approximation 1  in ' num2str(time_app1) ' s. Cost=' num2str(cost_OT_app1)]);


% compare estimated transport matrices between mu_x and mu_y
subplot 121
imagesc(-T);title('Transport matrix');colormap gray

subplot 122
imagesc(-T_approx);title('Approximate transport matrix');colormap gray











